Index: libfreeDiameter/fifo.c
===================================================================
--- libfreeDiameter/fifo.c	(revision 25)
+++ libfreeDiameter/fifo.c	(revision 14)
@@ -136,9 +136,8 @@
 }
 
-/* Delete a queue. It must be empty. */ 
+/* Delete a queue. It must be unused. */ 
 int fd_fifo_del ( struct fifo  ** queue )
 {
 	struct fifo * q;
-	int loops = 0;
 	
 	TRACE_ENTRY( "%p", queue );
@@ -150,24 +149,16 @@
 	CHECK_POSIX(  pthread_mutex_lock( &q->mtx )  );
 	
-	if ((q->count != 0) || (q->data != NULL)) {
-		TRACE_DEBUG(INFO, "The queue cannot be destroyed (%d, %p)", q->count, q->data);
+	if ((q->count != 0) || (q->thrs != 0) || (q->data != NULL)) {
+		TRACE_DEBUG(INFO, "The queue cannot be destroyed (%d, %d, %p)", q->count, q->thrs, q->data);
 		CHECK_POSIX_DO(  pthread_mutex_unlock( &q->mtx ), /* no fallback */  );
 		return EINVAL;
 	}
 	
+	/* sanity check */
+	ASSERT(FD_IS_LIST_EMPTY(&q->list));
+	
 	/* Ok, now invalidate the queue */
 	q->eyec = 0xdead;
 	
-	while (q->thrs) {
-		CHECK_POSIX(  pthread_cond_signal(&q->cond)  );
-		CHECK_POSIX(  pthread_mutex_unlock( &q->mtx ));
-		pthread_yield();
-		CHECK_POSIX(  pthread_mutex_lock( &q->mtx )  );
-		ASSERT( ++loops < 10 ); /* detect infinite loops */
-	}
-	
-	/* sanity check */
-	ASSERT(FD_IS_LIST_EMPTY(&q->list));
-	
 	/* And destroy it */
 	CHECK_POSIX(  pthread_mutex_unlock( &q->mtx )  );
@@ -179,57 +170,4 @@
 	free(q);
 	*queue = NULL;
-	
-	return 0;
-}
-
-/* Move the content of old into new, and update loc_update atomically */
-int fd_fifo_move ( struct fifo ** old, struct fifo * new, struct fifo ** loc_update )
-{
-	struct fifo * q;
-	int loops = 0;
-	
-	TRACE_ENTRY("%p %p %p", old, new, loc_update);
-	CHECK_PARAMS( old && CHECK_FIFO( *old ) && CHECK_FIFO( new ));
-	
-	q = *old;
-	CHECK_PARAMS( ! q->data );
-	if (new->high) {
-		TODO("Implement support for thresholds in fd_fifo_move...");
-	}
-	
-	/* Update loc_update */
-	*old = NULL;
-	if (loc_update)
-		*loc_update = new;
-	
-	/* Lock the queues */
-	CHECK_POSIX(  pthread_mutex_lock( &q->mtx )  );
-	CHECK_POSIX(  pthread_mutex_lock( &new->mtx )  );
-	
-	/* Any waiting thread on the old queue returns an error */
-	q->eyec = 0xdead;
-	while (q->thrs) {
-		CHECK_POSIX(  pthread_cond_signal(&q->cond)  );
-		CHECK_POSIX(  pthread_mutex_unlock( &q->mtx ));
-		pthread_yield();
-		CHECK_POSIX(  pthread_mutex_lock( &q->mtx )  );
-		ASSERT( ++loops < 10 ); /* detect infinite loops */
-	}
-	
-	/* Move all data from old to new */
-	fd_list_move_end( &new->list, &q->list );
-	if (q->count && (!new->count)) {
-		CHECK_POSIX(  pthread_cond_signal(&new->cond)  );
-	}
-	new->count += q->count;
-	
-	/* Destroy old */
-	CHECK_POSIX(  pthread_mutex_unlock( &q->mtx )  );
-	CHECK_POSIX(  pthread_cond_destroy( &q->cond )  );
-	CHECK_POSIX(  pthread_mutex_destroy( &q->mtx )  );
-	free(q);
-	
-	/* Unlock new, we're done */
-	CHECK_POSIX(  pthread_mutex_unlock( &new->mtx )  );
 	
 	return 0;
@@ -441,11 +379,4 @@
 awaken:
 	/* Check queue status */
-	if (!CHECK_FIFO( queue )) {
-		/* The queue is being destroyed */
-		CHECK_POSIX(  pthread_mutex_unlock( &queue->mtx )  );
-		TRACE_DEBUG(FULL, "The queue is being destroyed -> EPIPE");
-		return EPIPE;
-	}
-		
 	if (queue->count > 0) {
 		/* There are items in the queue, so pick the first one */
Index: libfreeDiameter/lists.c
===================================================================
--- libfreeDiameter/lists.c	(revision 25)
+++ libfreeDiameter/lists.c	(revision 14)
@@ -70,22 +70,4 @@
 	ASSERT(ref->head != item);
 	list_insert_after(ref, item);
-}
-
-/* Move all elements of list senti at the end of list ref */
-void fd_list_move_end(struct fd_list * ref, struct fd_list * senti)
-{
-	ASSERT(ref->head == ref);
-	ASSERT(senti->head == senti);
-	
-	if (senti->next == senti)
-		return;
-	
-	senti->next->prev = ref->prev;
-	ref->prev->next   = senti->next;
-	senti->prev->next = ref;
-	ref->prev         = senti->prev;
-	senti->prev = senti;
-	senti->next = senti;
-	
 }
 
Index: libfreeDiameter/log.c
===================================================================
--- libfreeDiameter/log.c	(revision 22)
+++ libfreeDiameter/log.c	(revision 2)
@@ -87,6 +87,6 @@
 }
 
-/* Write time into a buffer */
-char * fd_log_time ( struct timespec * ts, char * buf, size_t len )
+/* Write current time into a buffer */
+char * fd_log_time ( char * buf, size_t len )
 {
 	int ret;
@@ -96,15 +96,12 @@
 	
 	/* Get current time */
-	if (!ts) {
-		ret = clock_gettime(CLOCK_REALTIME, &tp);
-		if (ret != 0) {
-			snprintf(buf, len, "%s", strerror(ret));
-			return buf;
-		}
-		ts = &tp;
+	ret = clock_gettime(CLOCK_REALTIME, &tp);
+	if (ret != 0) {
+		snprintf(buf, len, "%s", strerror(ret));
+		return buf;
 	}
 	
-	offset += strftime(buf + offset, len - offset, "%D,%T", localtime_r( &ts->tv_sec , &tm ));
-	offset += snprintf(buf + offset, len - offset, ".%6.6ld", ts->tv_nsec / 1000);
+	offset += strftime(buf + offset, len - offset, "%D,%T", localtime_r( &tp.tv_sec , &tm ));
+	offset += snprintf(buf + offset, len - offset, ".%6.6ld", tp.tv_nsec / 1000);
 
 	return buf;
